/*
SECTRET KILLER MODE BY GREASERPIRATE
based on OrbitalDecay's Zombie Mod
*/


//number of victims the killer claims
int headcount = 0;
//collateral damage caused by teamkilling
int chaos = 0;
//if the killer is alive
int killeralive = 0;
//list of dead citizens
int deadCitizens = 0;
clientinfo *prevKiller; //to make sure no 2 Killers in a row
bool allpresent = false; //has everyone spawned? (prevents a bug)

struct killerservmode : servmode
{
    //amount each player has damaged the Killer.
    vector<int> damagecounter;
    //lists of killers and citizens
    vector<clientinfo *> killerList;
    vector<clientinfo *> citizenList;
    //unchanging list of everyone, synchronised w/ "damagecounter".
    vector<clientinfo *> totalList;

    /* This is called whenever a player enters the game. */
    void entergame(clientinfo *ci)
    {
    }

    /* This is called whenever a player leaves the game */
    void leavegame(clientinfo *ci, bool disconnecting = false)
    {
        /* Remove the player from the killer and citizen lists, if they're on
           them. */
        int n;
        n = killerList.find(ci);
        if (n >= 0)
	{
            killerList.remove(n);
	    if (killerList.length() < GAME(killers))
	    {
		makenewkiller();
	    }
	}
        n = citizenList.find(ci);
        if (n >= 0)
            citizenList.remove(n);
    }

    /* This is called every time a player moves */
    void moved(clientinfo *ci, const vec &oldpos, const vec &newpos)
    {
    }

    /* This is called when the server needs to know if a player can join a game */
    bool canspawn(clientinfo *ci, bool tryspawn = false)
    {
        return true;
    }

    /* This is called whenever someone spawns */
    void spawned(clientinfo *ci)
    {
	if ((GAME(killersurvivor) == 1 || m_duke(gamemode, mutators)) && killerList.length() < GAME(killers)) //make new Killers in Survivor:
	{
		if (allpresent == false)
		{
			allpresent = true;
			loopv(clients)
			{
				if (clients[i]->state.state != CS_ALIVE) allpresent = false;
			}
			if (allpresent == true) makenewkiller();
		}
		else makenewkiller();
	}
	//check to see if they're in the complete list:
	int n = totalList.find(ci);
        if (n < 0)
	{
		//add them to the complete list of all players
		totalList.add(ci);
		damagecounter.add(0);
	}
        /* If there aren't enough killers, make some*/
        if (GAME(killersurvivor) != 1 && killerList.length() < GAME(killers))
        {
	    if (GAME(killerlanguage == 1) || GAME(killerlanguage) == 3)
	    {
            	ancmsgft(ci->clientnum, S_GUIBACK, CON_EVENT, "\fs\fzoyYou are a killer! Frag everyone you can, but don't let them catch you!");
	    }
	    if (GAME(killerlanguage == 2) || GAME(killerlanguage) == 3)
	    {
            	ancmsgft(ci->clientnum, S_GUIBACK, CON_EVENT, "\fs\fzoyUsted es el Asesino! Encontrar y matar a los Ciudadanos. No dejes que te captura!");
	    }
            killerList.add(ci);
            ci->state.health = 100;
            sendf(-1, 1, "ri4", N_REGEN, ci->clientnum, GAME(spawnhealth), 0);
	    if (iscitizen(ci))
	    {
		int citizenLoc = citizenList.find(ci); //make them a non-citizen
		citizenList.remove(citizenLoc);
	    }
	}
        /* Prevent players from respawning as killers (w/full health) by changing weapons, suiciding, etc. Killers recieve no points from doing this. These actions are not prevented, they're just a "coward's way out". */
        else if (iskiller(ci) && prevKiller == ci)
        {	
            	int n = killerList.find(ci);
		killerList.remove(n);
		makenewkiller();
		//make previous killer a citizen
                citizenList.add(ci);
		//announce their giving up the job of Killer
		if (GAME(killerlanguage) == 1 || GAME(killerlanguage) == 3)
		{
                	ancmsgft(-1, S_GUIBACK, CON_EVENT, "%s [%d] has given up their life of crime", ci->name, ci->clientnum);
		}
		if (GAME(killerlanguage) == 2 || GAME(killerlanguage) == 3)
		{
                	ancmsgft(-1, S_GUIBACK, CON_EVENT, "%s [%d] reformada", ci->name, ci->clientnum);			
		}
        }
        /* If the player is a citizen, tell them so. */
        else if (iscitizen(ci))
        {

	    if (GAME(killerlanguage == 1) || GAME(killerlanguage) == 3)
	    {
            	ancmsgft(ci->clientnum, S_GUIBACK, CON_EVENT, "\fgYou are a normal citizen. Find and frag the killer, but don't kill civilians");
	    }
	    if (GAME(killerlanguage == 2) || GAME(killerlanguage) == 3)
	    {
            	ancmsgft(ci->clientnum, S_GUIBACK, CON_EVENT, "\fbUsted es un Ciudadano. Encontrar y matar al Asesino. No matar a los demas Ciudadanos.");
	    }
	}
        /* If a player is neither a citizen nor a killer, make them a citizen. */
        else
        {
	    if (GAME(killerlanguage == 1) || GAME(killerlanguage) == 3)
	    {
            	ancmsgft(ci->clientnum, S_GUIBACK, CON_EVENT, "\fgYou are a normal citizen. Find and frag the killer, but don't kill civilians.");
	    }
	    if (GAME(killerlanguage == 2) || GAME(killerlanguage) == 3)
	    {
            	ancmsgft(ci->clientnum, S_GUIBACK, CON_EVENT, "\fbUsted es un Ciudadano. Encontrar y matar al Asesino. No matar a los demas Ciudadanos.");
	    }
            citizenList.add(ci);
        }
    }

    /* This is called when a player kills another player.  Returns the number of
       points assigned. Does not seem to be working, possibly overriden somewhere else, but using "givepoints" works just fine */
    int points(clientinfo *victim, clientinfo *actor)
    {
	return 1;
    }

    /* This is called whenever someone dies */
    void died(clientinfo *victim, clientinfo *actor = NULL)
    {
	//WHEN A CITIZEN KILLS ANOTHER CITIZEN:	
	if (iscitizen(actor) && iscitizen(victim))	
	{	
		givepoints(actor, (GAME(killerteamkillpenalty) + GAME(fragbonus)) * -1);
		givepoints(victim, GAME(killerdyingpenalty) * -1);
		//Add 1 to the "chaos" value every time a citizen(not a bot) teamkills.
		if((actor->state.aitype < 0) || (GAME(killeraichaos) == 1))
		{
			chaos += 1;
		}
	}
	//WHEN A CITIZEN FRAGS A KILLER
	else if (iscitizen(actor) && iskiller(victim))
	{
		//The bounty for fragging Killers is determined by "killerbounty"
		givepoints(actor, GAME(killerbounty));
		//search through all the ciziens:
		for ( int n = 0; n < totalList.length(); n++)
		{
			clientinfo *recipient = totalList[n];
			if (iscitizen(recipient))
			{
				//give all citizens points when a killer is caught
				givepoints(recipient, GAME(killermutualbounty));
				//give them their share of the Killer's damage
				givepoints(recipient, damagecounter[n] * GAME(killerdamagepoints) * 100 / GAME(spawnhealth));
				//Reset the damage counter
				damagecounter[n] = 0;
			}
		}
	}
	//WHEN A KILLER FRAGS A CITIZEN:	
	else if (iskiller(actor) && iscitizen(victim))
	{
		//Killers don'y immedietly get points, the "headcount" var is raised
		givepoints(actor, GAME(fragbonus) * -1);
		headcount += 1;
	}
	//WHEN A KILLER DIES(any cause of death):
	if (iskiller(victim))
        {
            int n = killerList.find(victim);
            if (n >= 0) //just to make sure the location is right
            {
		string english;
		string spanish;
		if (actor)
		{
			formatstring(english)("The Killer, %s [%d], was brought to justice by %s [%d] (%d victims, %d innocents punished)", victim->name, victim->clientnum, actor->name, actor->clientnum, headcount, chaos);
			formatstring(spanish)("\fbel Asesino, %s [%d], fue llevado ante la justicia, porque de %s [%d] (%d victimas, %d Ciudadanos se mataban entre si)", victim->name, victim->clientnum, actor->name, actor->clientnum, headcount, chaos);
		}
		else
		{
			formatstring(english)("The Killer, %s [%d], was brought to justice! (%d victims, %d innocents punished)", victim->name, victim->clientnum, headcount, chaos);
			formatstring(spanish)("\fbel Asesino, %s [%d], fue llevado ante la justicia! (%d victimas, %d Ciudadanos se mataban entre si)", victim->name, victim->clientnum, headcount, chaos);
		}
		if (GAME(killerlanguage) == 1 || GAME(killerlanguage) == 3)
		{
			ancmsgft(-1, S_GUIBACK, CON_EVENT, "%s", english);
			conoutft(1, "%s", english);			
		}
		if (GAME(killerlanguage) == 2 || GAME(killerlanguage) == 3)
		{
			ancmsgft(-1, S_GUIBACK, CON_EVENT, "%s", spanish);
			conoutft(1, "%s", spanish);			
		}
		// Killers stop being killers               
		killerList.remove(n);
		//killers finally get their reward, but also get a penalty for dying
		givepoints(victim, GAME(fragbonus) * headcount);
		givepoints(victim, GAME(killerchaospoints) * chaos);
		givepoints(victim, GAME(killerjusticepenalty) * -1);
		headcount = 0;
		chaos = 0;
		//another killer is chosen
		if (GAME(killersurvivor) != 1) //unless it's Survivor Mode
		{
			makenewkiller();
		}
		//the previous killer becomes a normal citizen
                citizenList.add(victim);
		if (m_duke(gamemode, mutators)) //if it is truly survivor:
		{
			killerList.shrink(0);
			killeralive = 0;
			deadCitizens = 0;
			loopv(clients)
			{
				clients[i]->state.state = CS_WAITING; //kill everyone
			}
			deadCitizens = 0;
		}
		else if (GAME(killersurvivor) == 1) //if it's only Ticket mode
		{
			killerList.shrink(0);
			if (GAME(killerreinforcements) == -1) deadCitizens = 0;
			else
			{
				deadCitizens -= GAME(killerreinforcements);
				deadCitizens += abs(deadCitizens);
				deadCitizens *= 0.5;
			}
		}
            }
        }
	//WHEN A CITIZEN DIES(any cause):
	else if (iscitizen(victim))
	{
		if ((m_duke(gamemode, mutators) || GAME(killersurvivor) == 1) && killerList.length() > 0) //if it's survivor mode:
		{
			deadCitizens = deadCitizens + 1;
			if (GAME(killerlanguage) == 1 || GAME(killerlanguage) == 3)
			{
				ancmsgft(-1, S_GUIBACK, CON_EVENT,"the innocent civillian %s [%d] has been killed! (%d citizens remaining)", victim->name, victim->clientnum, citizenList.length() - deadCitizens + GAME(killerextracitizens));
			}
			if (GAME(killerlanguage) == 2 || GAME(killerlanguage) == 3)
			{
				ancmsgft(-1, S_GUIBACK, CON_EVENT,"\fbel ciudadano, %s [%d], murio! (%d a los ciudadanos restantes))", victim->name, victim->clientnum, citizenList.length() - deadCitizens + GAME(killerextracitizens));
			}
			if (deadCitizens >= citizenList.length() + GAME(killerextracitizens)) //if all the citizens are dead:
			{
				loopv(killerList) //go through all the Killers:
				{
					//killers finally get their reward, and a bonus
					givepoints(killerList[i], GAME(fragbonus) * headcount);
					givepoints(killerList[i], GAME(killerchaospoints) * chaos);
					givepoints(killerList[i], GAME(killersuccessbonus));
					// no more Killers
					killerList.shrink(0);
					ancmsgft(-1, S_GUIBACK, CON_EVENT, "the infamous killer %s [%d] has fragged all the citizens! (%d victims, %d innocents falsely punished)", killerList[i]->name, killerList[i]->clientnum, headcount, chaos);
					if (GAME(killerlanguage) == 2 || GAME(killerlanguage) == 3)
					{
						ancmsgft(-1, S_GUIBACK, CON_EVENT, "\fbel Asesino, %s [%d], mato a todos los Ciudadanos! (%d victimas, %d Ciudadanos se mataban entre si)", killerList[i]->name, killerList[i]->clientnum, headcount, chaos);
					}
				}
				deadCitizens = 0;
				killeralive = 0;
				loopv(clients)
				{
					clients[i]->state.state = CS_WAITING; //kill everyone
				}
				deadCitizens = 0;
			}
		}
	}

    }

    /* In theory, this is called when someone changes teams.  I don't think
       it is actually used in practice. */
    void changeteam(clientinfo *ci, int oldteam, int newteam)
    {
    }
    
    /* Called when a client first connects.  Used for low level networking stuff
       if there is any extra information we want to append to the packet. */
    void initclient(clientinfo *ci, packetbuf &p, bool connecting)
    {
    }

    /* Called every frame */
    void update()
    {	
    }

    /* Called when the server is reset */
    void reset(bool empty)
    {
        killerList.shrink(0);
        citizenList.shrink(0);
	totalList.shrink(0);
	prevKiller = NULL;
	allpresent = false;
    }

    /* No clue */
    void layout()
    {
    }

    /* This is called when intermission begins */
    void intermission()
    {
	for (int n = 0; n < killerList.length(); n++)
	{
		prevKiller = NULL;
		clientinfo *finalkiller = killerList[n];
		givepoints(finalkiller, GAME(fragbonus) * headcount);
		givepoints(finalkiller, GAME(killerchaospoints) * chaos);
		//annoucne the final killer
		if (GAME(killerlanguage) == 1 || GAME(killerlanguage) == 3)
		{
                ancmsgft(-1, S_GUIBACK, CON_EVENT, "%s [%d] was the final killer! (%d victims, %d innocents punished)",finalkiller->name, finalkiller->clientnum, headcount, chaos);
		}
		if (GAME(killerlanguage) == 2 || GAME(killerlanguage) == 3)
		{
                ancmsgft(-1, S_GUIBACK, CON_EVENT, "%s era el Asesino ultima! (%d victimas, %d Ciudadanos se mataban entre si)",finalkiller->name, finalkiller->clientnum, headcount, chaos);
		}
	}
    }

    /* This is called when someone actually deals damage to someone else */
    bool damage(clientinfo *target,
                clientinfo *actor,
                int damage,
                int weap,
                int flags,
                const ivec &hitpush = ivec(0, 0, 0))
    {
        return true;
    }

    /* Called before damage is dealt */
    void dodamage(clientinfo *target,
                  clientinfo *actor,
                  int &damage,
                  int &hurt,
                  int &weap,
                  int &flags,
                  const ivec &hitpush = ivec(0, 0, 0))
    {
        /* Damage dealt by killers is scaled by sv_killerdamage */
        if (iskiller(target))
        {
	    /* Undo whatever damage has already been applied */
            target->state.health += damage;

            /*Killers always take damage from headshots, but body damage is scaled*/
            if (iskiller(target) && hithead(flags))
	    {
            	target->state.health -= damage;
	    }
            else if (iskiller(target) && !hithead(flags))
	    {
		//scale damage to "killerbodydamage"   	
		damage *= GAME(killerbodydamage); //scale damage
		//add one damage points for rounding, but not if the weap is Flamer
		if ((weap != 5) && (weap != 15) && (GAME(killerbodydamage) != 0))
		{
			damage += 1;
		}
	    	target->state.health -= damage; //re-apply
	    	//add to the attacker's "damage counter"
		if ((actor))
		{
			for (int n = 0; n <= totalList.length(); n++)
			{
				clientinfo *recipient = totalList[n];
				if (recipient == actor)
				{
					damagecounter[n] += damage;
				}
			}
		}
	    }
            if (target->state.health <= 0)
                flags |= HIT_KILL;
        }
	else if (iscitizen(target))
	{
	    target->state.health += damage; //undo damage
	    damage *= GAME(killerdamage); //scale damage
	    target->state.health -= damage; //re-apply
	    
	}
    }

    /* Called every frame with regen info... does not seem to be working */
    void regen(clientinfo *ci, int &total, int &amt, int &delay)
    {
    }

    /* Let players change teams */
    void setteam(clientinfo *ci, int team)
    {
    }

    /* Turn a player into a killer */
    void corrupt(clientinfo *ci)
    {
        int n;
        n = citizenList.find(ci);
        if (n >= 0)
	{
            citizenList.remove(n);
	}
        if (!iskiller(ci))
	{
	    if (GAME(killerlanguage == 1) || GAME(killerlanguage) == 3)
	    {
            	ancmsgft(ci->clientnum, S_GUIBACK, CON_EVENT, "\fs\fzoyYou are a killer! Frag everyone you can, but don't let them catch you!");
	    }
	    if (GAME(killerlanguage == 2) || GAME(killerlanguage) == 3)
	    {
            	ancmsgft(ci->clientnum, S_GUIBACK, CON_EVENT, "\fs\fzoyUsted es el Asesino! Encontrar y matar a los Ciudadanos. No dejes que te captura!");
	    }
            killerList.add(ci);
            ci->state.health = GAME(spawnhealth);
            sendf(-1, 1, "ri4", N_REGEN, ci->clientnum, GAME(spawnhealth), 0);
	    //tell whether they're alive or dead
	    prevKiller = ci;
	}
    }

    /* Returns true if a player is a killer, false otherwise */
    bool iskiller(clientinfo *ci)
    {
        return (killerList.find(ci) >= 0);
    }

    /* Returns true if a player is a citizen, false otherwise */
    bool iscitizen(clientinfo *ci)
    {
        return (citizenList.find(ci) >= 0);
    }

    void makenewkiller() //randomly create a new killer
    {
	int newkillernum = rand() % citizenList.length();
	clientinfo *newkiller = citizenList[newkillernum];
	if (newkiller->state.state == CS_ALIVE || GAME(killersurvivor) != 1 ) //unless it's Survivor and the chosen one is dead:
		corrupt(newkiller); //create a new killer
    }

    char *correctname(clientinfo *ci) //write the right name for a bot/human ("ci")
    {
	string name;
	if (ci->state.aitype >= 0) //if "ci" is a bot:
	{
		formatstring(name)("%s [%d]", ci->name, ci->clientnum);
	}
	else if (ci->state.aitype < 0) //if "ci" is human:
	{
		formatstring(name)("%s", ci->name);
	}
	//char *pointer;
	//pointer = name;
	return name;
    }
} killermut; 
